require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.
#
# Also compared to earlier versions of this generator, there are no longer any
# expectations of assigns and templates rendered. These features have been
# removed from Rails core in Rails 5, but can be added back in via the
# `rails-controller-testing` gem.

RSpec.describe Api::V1::UsersManagement::RolesController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # Api::V1::UsersManagement::Role. As you add validations to Api::V1::UsersManagement::Role, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    {
      name: 'role_test',
      display_name: 'Role Test',
      description: 'Role test'  

    }
  }

  let(:invalid_attributes) {
    {description: 'Role 12'}
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # Api::V1::UsersManagement::RolesController. Be sure to keep this updated too.
  let(:valid_session) {}

  describe "authorized user" do
    login_super_admin

    describe "GET #index" do
      it "returns a success response" do
        role = FactoryBot.create(:user_role, valid_attributes)
        get :index, params: {format: :json}, session: valid_session
        expect(response).to be_success
      end
    end

    describe "GET #show" do
      it "returns a success response" do
        role = FactoryBot.create(:user_role, valid_attributes)
        get :show, params: {format: :json, id: role.id.to_s}, session: valid_session
        expect(response).to be_success
      end
    end

    describe "POST #create" do
      context "with valid params" do
        it "renders a JSON response with the new api_v1_users_management_roles" do
          post :create, params: {role: valid_attributes, format: :json}, session: valid_session
          expect(response).to have_http_status(:created)
          expect(response.content_type).to eq('application/json')
          expect(response.location).to eq(api_v1_users_management_role_url(::User::Role.last))
        end
      end

      context "with invalid params" do
        it "renders a JSON response with errors for the new api_v1_users_management_roles" do

          post :create, params: {role: invalid_attributes, format: :json}, session: valid_session
          expect(response).to have_http_status(:unprocessable_entity)
          expect(response.content_type).to eq('application/json')
        end
      end
    end

    describe "PUT #update" do
      context "with valid params" do
        let(:new_attributes) {
           {
            name: 'role_test_2',
            display_name: 'Role Test 2',
            description: 'Role test 2'  
          }
        }

        it "updates the requested api_v1_users_management_roles" do
          role = ::FactoryBot.create(:user_role, valid_attributes)
          put :update, params: {id: role.id.to_s, role: new_attributes, format: :json}, session: valid_session
          role.reload
         
          expect(role.name).to eql(new_attributes[:name])
        end

        it "renders a JSON response with the api_v1_users_management_roles" do
          role = ::FactoryBot.create(:user_role, valid_attributes)

          put :update, params: {id: role.id.to_s, role: new_attributes, format: :json}, session: valid_session
          role.reload
         
          expect(role.name).to eql(new_attributes[:name])
          expect(response).to have_http_status(:ok)
          expect(response.content_type).to eq('application/json')
        end
      end

      context "with invalid params" do
        it "renders a JSON response with errors for the api_v1_users_management_roles" do
          role = FactoryBot.create(:user_role, valid_attributes)

          put :update, params: {id: role.id.to_s, role: {name: nil}, format: :json}, session: valid_session
          role.reload
         
          expect(role.name).to eql(valid_attributes[:name])
          expect(response).to have_http_status(:unprocessable_entity)
          expect(response.content_type).to eq('application/json')
        end
      end
    end

    describe "DELETE #destroy" do
      it "destroys the requested api_v1" do
        role = FactoryBot.create(:user_role, valid_attributes)
        expect {
          delete :destroy, params: {id: role.id.to_s}, session: valid_session
        }.to change(::User::Role, :count).by(-1)
      end
    end
  end

  describe "unauthorized user" do
    login_user

    describe "GET #index" do
      it "returns a success response" do
        role = FactoryBot.create(:user_role, valid_attributes)
        get :index, params: {format: :json}, session: valid_session
        expect(response).to have_http_status(:unauthorized)
      end
    end

    describe "GET #show" do
      it "returns a success response" do
        role = FactoryBot.create(:user_role, valid_attributes)
        get :show, params: {format: :json, id: role.id.to_s}, session: valid_session
        expect(response).to have_http_status(:unauthorized)
      end
    end

    describe "POST #create" do
      context "with valid params" do
        it "renders a JSON response with the new api_v1_users_management_roles" do
          post :create, params: {role: valid_attributes, format: :json}, session: valid_session
          expect(response).to have_http_status(:unauthorized)
        end
      end
    end

    describe "PUT #update" do
      context "with valid params" do
        it "updates the requested api_v1_users_management_roles" do
          role = ::FactoryBot.create(:user_role, valid_attributes)
          put :update, params: {id: role.id.to_s, role: {description: nil}, format: :json}, session: valid_session
          expect(response).to have_http_status(:unauthorized)
        end
      end
    end

    describe "DELETE #destroy" do
      it "destroys the requested api_v1" do
        role = FactoryBot.create(:user_role, valid_attributes)
        delete :destroy, params: {id: role.id.to_s}, session: valid_session
        expect(response).to have_http_status(:unauthorized)
      end
    end
  end
end
